#################
# BEGIN: intt(In)
# LIB:intt():2018.257
#   Handles all of the annoying shortfalls of the int() function (vs C).
def intt(In):
    In = str(In).strip()
    if len(In) == 0:
        return 0
    # Let the system try it first.
    try:
        return int(In)
    except ValueError:
        Number = ""
        for c in In:
            if c.isdigit():
                Number += c
            elif (c == "-" or c == "+") and len(Number) == 0:
                Number += c
            elif c == ",":
                continue
            else:
                break
        try:
            return int(Number)
        except ValueError:
            return 0
# END: intt

###################
# BEGIN: floatt(In)
# LIB:floatt():2018.256
#    Handles all of the annoying shortfalls of the float() function (vs C).
#    Does not handle scientific notation numbers.
def floatt(In):
    In = str(In).strip()
    if len(In) == 0:
        return 0.0
    # At least let the system give it the ol' college try.
    try:
        return float(In)
    except Exception:
        Number = ""
        for c in In:
            if c.isdigit() or c == ".":
                Number += c
            elif (c == "-" or c == "+") and len(Number) == 0:
                Number += c
            elif c == ",":
                continue
            else:
                break
        try:
            return float(Number)
        except ValueError:
            return 0.0
# END: floatt

######################################
# BEGIN: rtnPattern(In, Upper = False)
# this may need to be moved to another place
# LIB:rtnPattern():2006.114
def rtnPattern(In, Upper=False):
    Rtn = ""
    for c in In:
        if c.isdigit():
            Rtn += "0"
        elif c.isupper():
            Rtn += "A"
        elif c.islower():
            Rtn += "a"
        else:
            Rtn += c
    # So the A/a chars will always be A, so the caller knows what to look for.
    if Upper is True:
        return Rtn.upper()
    return Rtn
# END: rtnPattern